unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleServer, WbemScripting_TLB, ComCtrls;

type
  TfrmMain = class(TForm)
    btnShutdown: TButton;
    btnReboot: TButton;
    mWMI: TMemo;
    btnGetWMI: TButton;
    edtComputer: TEdit;
    edtNamespace: TEdit;
    edtClass: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    edtUser: TEdit;
    Label8: TLabel;
    edtPass: TEdit;
    btnPopup: TButton;
    procedure btnShutdownClick(Sender: TObject);
    procedure btnRebootClick(Sender: TObject);
    procedure btnGetWMIClick(Sender: TObject);
    procedure btnPopupClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.DFM}
uses ActiveX, ComObj, Variants;

(* ************************************************************************* *)

procedure TfrmMain.btnShutdownClick(Sender: TObject);
var
  wmiLocator:   TSWbemLocator;
  wmiServices:  ISWbemServices;
  wmiObjectSet: ISWbemObjectSet;
  wmiObject:    ISWbemObject;
  Enum:         IEnumVariant;
  ovVar:        OleVariant;
  lwValue:      LongWord;

begin
  wmiLocator  := TSWbemLocator.Create(self);
  wmiServices := wmiLocator.ConnectServer(
                        'devcam',
                        'root\cimv2',
                        'Administrator',
                        'richplum', '',
                        '', 0, nil);
  wmiServices.Security_.Privileges.Add(wbemPrivilegeShutdown, True);
  wmiObjectSet := wmiServices.ExecQuery('SELECT * FROM Win32_OperatingSystem WHERE Primary=True', 'WQL', wbemFlagReturnImmediately, nil);
  Enum :=  (wmiObjectSet._NewEnum) as IEnumVariant;
  while (Enum.Next(1, ovVar, lwValue) = S_OK) do  begin
    wmiObject := IUnknown(ovVar) as SWBemObject;
    wmiObject.ExecMethod_('Shutdown', nil, 0, nil);
  end;

  wmiLocator.Free;
end;

(* ************************************************************************* *)

procedure TfrmMain.btnRebootClick(Sender: TObject);
var
  wmiLocator:   TSWbemLocator;
  wmiServices:  SWbemServices;
  wmiObjectSet: SWbemObjectSet;
  wmiInst,
  wmiParams,
  wmiObject:    SWbemObject;

  Enum:         IEnumVariant;
  propValue,
  ovVar:        OleVariant;
  lwValue:      LongWord;
  wmiMethod:    SWbemMethod;
  wmiProperty:  SWbemProperty;

begin
  wmiLocator  := TSWbemLocator.Create(self);
  wmiServices := wmiLocator.ConnectServer(
                        'devcam',
                        'root\cimv2',
                        'Administrator',
                        'richplum', '',
                        '', 0, nil);

  wmiServices.Security_.Privileges.Add(wbemPrivilegeShutdown, True);

  wmiObjectSet := wmiServices.ExecQuery(
    'SELECT * FROM Win32_OperatingSystem WHERE Primary=True',
    'WQL', wbemFlagReturnImmediately, nil);

  Enum :=  (wmiObjectSet._NewEnum) as IEnumVariant;
  while (Enum.Next(1, ovVar, lwValue) = S_OK) do begin
    wmiObject   := IUnknown(ovVar) as SWBemObject;
    wmiMethod   := wmiObject.Methods_.Item('Win32Shutdown', 0);
    wmiParams   := wmiMethod.InParameters;
    wmiInst     := wmiParams.SpawnInstance_(0);
    wmiProperty := wmiInst.Properties_.Add('Flags', wbemCimtypeSint32, False, 0);
    propValue   := EWX_REBOOT;
    wmiProperty.Set_Value(propValue);

    wmiObject.ExecMethod_('Win32Shutdown', wmiInst, 0, nil);
  end;

  wmiLocator.Free;
end;

(* ************************************************************************* *)

procedure TfrmMain.btnGetWMIClick(Sender: TObject);
var
  wmiLocator:   TSWbemLocator;
  wmiServices:  ISWbemServices;
  wmiObjectSet: ISWbemObjectSet;
  wmiObject:    ISWbemObject;
  propSet:      ISWbemPropertySet;
  wmiProp:      ISWbemProperty;
  propEnum,
  Enum:         IEnumVariant;
  ovVar:        OleVariant;
  Count:        Integer;
  lwValue:      LongWord;
  sValue:       String;
begin
  wmiLocator    := TSWbemLocator.Create(self);
  if edtPass.Text = '' then edtUser.Text := '';

  try
    wmiServices := wmiLocator.ConnectServer(
                     edtComputer.Text,
                     edtNamespace.Text,
                     edtUser.Text,
                     edtPass.Text,
                     '', '', 0, nil);

//    wmiObjectSet := wmiServices.ExecQuery(
//      'SELECT * FROM ' + edtClass.Text,
//      'WQL',
//      wbemFlagReturnImmediately, nil);

    // Obtain an instance of the WMI class
    wmiObjectSet := wmiServices.InstancesOf(
                      'Win32_OperatingSystem',
                      wbemFlagReturnImmediately or
                      wbemQueryFlagShallow, nil);

    // Replicate VBScript's "for each" construct                      
    Enum := (wmiObjectSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, ovVar, lwValue) = S_OK) do begin
      wmiObject := IUnknown(ovVar) as SWBemObject;
      propSet   := wmiObject.Properties_;
      propEnum  := (propSet._NewEnum) as IEnumVariant;

       // Replicate VBScript's "for each" construct
      while (propEnum.Next(1, ovVar, lwValue) = S_OK) do begin
        wmiProp  := IUnknown(ovVar) as SWBemProperty;
        sValue := '';
        if VarIsNull(wmiProp.Get_Value) then
          sValue := 'Is Null'
        else
        case wmiProp.CIMType of
          wbemCimtypeSint8,
          wbemCimtypeUint8,
          wbemCimtypeSint16,
          wbemCimtypeUint16,
          wbemCimtypeSint32,
          wbemCimtypeUint32,
          wbemCimtypeSint64:
            if VarIsArray(wmiProp.Get_Value) then begin
              if VarArrayHighBound(wmiProp.Get_Value, 1) > 0 then
                for Count := 1 to VarArrayHighBound(wmiProp.Get_Value, 1) do
                  sValue := sValue + ' ' + IntToStr(wmiProp.Get_Value[Count]);
            end
            else
              sValue := IntToStr(wmiProp.Get_Value);

          wbemCimtypeReal32,
          wbemCimtypeReal64:
            sValue := FloatToStr(wmiProp.Get_Value);

          wbemCimtypeBoolean:
            if wmiProp.Get_Value then sValue := 'True' else sValue := 'False';

          wbemCimtypeString,
          wbemCimtypeUint64:
            if VarIsArray(wmiProp.Get_Value) then begin
              if VarArrayHighBound(wmiProp.Get_Value, 1) > 0 then
                for Count := 1 to VarArrayHighBound(wmiProp.Get_Value, 1) do
                  sValue := sValue + ' ' + wmiProp.Get_Value[Count];
            end
            else
              sValue :=  wmiProp.Get_Value;

          wbemCimtypeDatetime:
            sValue :=  wmiProp.Get_Value;
        end;
        mWMI.Lines.Add(wmiProp.Name + ' = ' + sValue);
      end;
    end;
  finally
    wmiLocator.Free;
  end;
end;

(* ************************************************************************* *)

procedure TfrmMain.btnPopupClick(Sender: TObject);
var
  wmiLocator:   TSWbemLocator;
  wmiServices:  ISWbemServices;
  wmiObjectSet: ISWbemObjectSet;
  wmiObject:    ISWbemObject;
  Enum:         IEnumVariant;
  ovVar:        OleVariant;
  lwValue:      LongWord;
begin
  wmiLocator    := TSWbemLocator.Create(self);
  if edtPass.Text = '' then edtUser.Text := '';

  try
    wmiServices := wmiLocator.ConnectServer(
                     edtComputer.Text,
                     edtNamespace.Text,
                     edtUser.Text,
                     edtPass.Text,
                     '', '', 0, nil);

    wmiObjectSet := wmiServices.ExecQuery(
      'SELECT Caption,CSDVersion FROM  Win32_OperatingSystem',// ' + edtClass.Text,
     'WQL',
      wbemFlagReturnImmediately, nil);

    // Obtain an instance of the WMI class
//    wmiObjectSet := wmiServices.InstancesOf(
//                      'Win32_OperatingSystem',
//                      wbemFlagReturnImmediately or
//                      wbemQueryFlagShallow, nil);

    // Replicate VBScript's "for each" construct
    Enum := (wmiObjectSet._NewEnum) as IEnumVariant;
    while (Enum.Next(1, ovVar, lwValue) = S_OK) do begin
      wmiObject := IUnknown(ovVar) as SWBemObject;
      Showmessage(wmiObject.GetObjectText_(0));
    end;
  finally
    wmiLocator.Free;
  end;
end;

end.
